/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.records;


import com.tabajara.base.tables.Grpacesso;
import com.tabajara.base.tables.interfaces.IGrpacesso;

import io.github.jklingsporn.vertx.jooq.shared.internal.VertxPojo;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record3;
import org.jooq.Row3;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class GrpacessoRecord extends UpdatableRecordImpl<GrpacessoRecord> implements VertxPojo, Record3<Integer, String, Boolean>, IGrpacesso {

    private static final long serialVersionUID = -967124578;

    /**
     * Setter for <code>public.grpacesso.grpid</code>.
     */
    @Override
    public GrpacessoRecord setGrpid(Integer value) {
        set(0, value);
        return this;
    }

    /**
     * Getter for <code>public.grpacesso.grpid</code>.
     */
    @Override
    public Integer getGrpid() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>public.grpacesso.grpdescricao</code>.
     */
    @Override
    public GrpacessoRecord setGrpdescricao(String value) {
        set(1, value);
        return this;
    }

    /**
     * Getter for <code>public.grpacesso.grpdescricao</code>.
     */
    @Override
    public String getGrpdescricao() {
        return (String) get(1);
    }

    /**
     * Setter for <code>public.grpacesso.grpativo</code>.
     */
    @Override
    public GrpacessoRecord setGrpativo(Boolean value) {
        set(2, value);
        return this;
    }

    /**
     * Getter for <code>public.grpacesso.grpativo</code>.
     */
    @Override
    public Boolean getGrpativo() {
        return (Boolean) get(2);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record3 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row3<Integer, String, Boolean> fieldsRow() {
        return (Row3) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row3<Integer, String, Boolean> valuesRow() {
        return (Row3) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field1() {
        return Grpacesso.GRPACESSO.GRPID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field2() {
        return Grpacesso.GRPACESSO.GRPDESCRICAO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Boolean> field3() {
        return Grpacesso.GRPACESSO.GRPATIVO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component1() {
        return getGrpid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component2() {
        return getGrpdescricao();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Boolean component3() {
        return getGrpativo();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value1() {
        return getGrpid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value2() {
        return getGrpdescricao();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Boolean value3() {
        return getGrpativo();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public GrpacessoRecord value1(Integer value) {
        setGrpid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public GrpacessoRecord value2(String value) {
        setGrpdescricao(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public GrpacessoRecord value3(Boolean value) {
        setGrpativo(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public GrpacessoRecord values(Integer value1, String value2, Boolean value3) {
        value1(value1);
        value2(value2);
        value3(value3);
        return this;
    }

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public void from(IGrpacesso from) {
        setGrpid(from.getGrpid());
        setGrpdescricao(from.getGrpdescricao());
        setGrpativo(from.getGrpativo());
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public <E extends IGrpacesso> E into(E into) {
        into.from(this);
        return into;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached GrpacessoRecord
     */
    public GrpacessoRecord() {
        super(Grpacesso.GRPACESSO);
    }

    /**
     * Create a detached, initialised GrpacessoRecord
     */
    public GrpacessoRecord(Integer grpid, String grpdescricao, Boolean grpativo) {
        super(Grpacesso.GRPACESSO);

        set(0, grpid);
        set(1, grpdescricao);
        set(2, grpativo);
    }

    public GrpacessoRecord(io.vertx.core.json.JsonObject json) {
        this();
        fromJson(json);
    }
}
